%macro fcf_iem_load_alert_rels(ds=);

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TB * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    FSK_ALERT - &db_kc_libname..FSK_ALERT A5DG55RP.BH00019G * 
 * Target Table:    Extract - work.W2NSDOYP               A5DG55RP.BR0001TZ * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(&ds); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NSDOYP;
quit;

proc sql;
   create view work.W2NSDOYP as
      select
         (CATX('-','ALT',compress(put(ALERT_ID,32.)))) as alert_id length = 32
            format = $32.
            informat = $32.
            label = 'alert_id',
         (CATX('-','ACC',PRIMARY_ENTITY_NUMBER)) as primary_entity_number length = 50
            format = $50.
            informat = $50.
            label = 'primary_entity_number'
   from &SOURCEDS
      where PRIMARY_ENTITY_LEVEL_CODE = "ACC" & SEGMENT_ID = "&segKCSchema"
   ;
quit;

%let SOURCEDS = work.W2NSDOYP;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TC * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    FSK_ALERT - &db_kc_libname..FSK_ALERT A5DG55RP.BH00019G * 
 * Target Table:    Extract - work.W2NSEBPJ               A5DG55RP.BR0001U0 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(&ds); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NSEBPJ;
quit;

proc sql;
   create view work.W2NSEBPJ as
      select
         (CATX('-','ALT',compress(put(ALERT_ID,32.)))) as alert_id length = 32
            format = $32.
            informat = $32.
            label = 'alert_id',
         (CATX('-','ASC',PRIMARY_ENTITY_NUMBER)) as primary_entity_number length = 50
            format = $50.
            informat = $50.
            label = 'primary_entity_number'
   from &SOURCEDS
      where primary_entity_level_code = "ASC" & SEGMENT_ID = "&segKCSchema"
   ;
quit;

%let SOURCEDS = work.W2NSEBPJ;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TD * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    FSK_ALERT - &db_kc_libname..FSK_ALERT A5DG55RP.BH00019G * 
 * Target Table:    Extract - work.W2NSEULT               A5DG55RP.BR0001U1 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(&ds); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NSEULT;
quit;

proc sql;
   create view work.W2NSEULT as
      select
         (CATX('-','ALT',compress(put(ALERT_ID,32.)))) as alert_id length = 32
            format = $32.
            informat = $32.
            label = 'alert_id',
         (CATX('-','HHD',PRIMARY_ENTITY_NUMBER)) as primary_entity_number length = 50
            format = $50.
            informat = $50.
            label = 'primary_entity_number'
   from &SOURCEDS
      where primary_entity_level_code = "HHD" & SEGMENT_ID = "&segKCSchema"
   ;
quit;

%let SOURCEDS = work.W2NSEULT;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TE * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    FSK_ALERT - &db_kc_libname..FSK_ALERT A5DG55RP.BH00019G * 
 * Target Table:    Extract - work.W2NSG82S               A5DG55RP.BR0001U2 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(&ds); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NSG82S;
quit;

proc sql;
   create view work.W2NSG82S as
      select
         (CATX('-','ALT',compress(put(ALERT_ID,32.)))) as alert_id length = 32
            format = $32.
            informat = $32.
            label = 'alert_id',
         (CATX('-','PTY',PRIMARY_ENTITY_NUMBER)) as primary_entity_number length = 50
            format = $50.
            informat = $50.
            label = 'primary_entity_number'
   from &SOURCEDS
      where primary_entity_level_code = "PTY" & SEGMENT_ID = "&segKCSchema"
   ;
quit;

%let SOURCEDS = work.W2NSG82S;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TF * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    FSK_ALERT - &db_kc_libname..FSK_ALERT A5DG55RP.BH00019G * 
 * Target Table:    Extract - work.W2NSGXF5               A5DG55RP.BR0001U3 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(&ds); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NSGXF5;
quit;

proc sql;
   create view work.W2NSGXF5 as
      select
         (CATX('-','ALT',compress(put(ALERT_ID,32.)))) as alert_id length = 32
            format = $32.
            informat = $32.
            label = 'alert_id',
         (CATX('-','EXT',PRIMARY_ENTITY_NUMBER)) as primary_entity_number length = 50
            format = $50.
            informat = $50.
            label = 'primary_entity_number'
   from &SOURCEDS
      where primary_entity_level_code = "EXT" & SEGMENT_ID = "&segKCSchema"
   ;
quit;

%let SOURCEDS = work.W2NSGXF5;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TG * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    PARTY_LIVE - ecm_db.PARTY_LIVE        A5DG55RP.BH00019W * 
 * Target Table:    Extract - work.W2NQKB9C               A5DG55RP.BR0001U4 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.PARTY_LIVE); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NQKB9C;
quit;

proc sql;
   create view work.W2NQKB9C as
      select
         PARTY_RK,
         PARTY_ID
   from &SOURCEDS
      where PARTY_TYPE_CD = "FCFSUB"  & PARTY_CATEGORY_CD = "ACC"
   ;
quit;

%let SOURCEDS = work.W2NQKB9C;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TH * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    PARTY_LIVE - ecm_db.PARTY_LIVE        A5DG55RP.BH00019W * 
 * Target Table:    Extract - work.W2NQL020               A5DG55RP.BR0001U5 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.PARTY_LIVE); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NQL020;
quit;

proc sql;
   create view work.W2NQL020 as
      select
         PARTY_RK,
         PARTY_ID
   from &SOURCEDS
      where PARTY_TYPE_CD = "FCFSUB"  & PARTY_CATEGORY_CD = "ASC"
   ;
quit;

%let SOURCEDS = work.W2NQL020;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TI * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    PARTY_LIVE - ecm_db.PARTY_LIVE        A5DG55RP.BH00019W * 
 * Target Table:    Extract - work.W2NQLMG0               A5DG55RP.BR0001U6 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.PARTY_LIVE); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NQLMG0;
quit;

proc sql;
   create view work.W2NQLMG0 as
      select
         PARTY_RK,
         PARTY_ID
   from &SOURCEDS
      where PARTY_TYPE_CD = "FCFSUB"  & PARTY_CATEGORY_CD = "HHD"
   ;
quit;

%let SOURCEDS = work.W2NQLMG0;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TJ * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    PARTY_LIVE - ecm_db.PARTY_LIVE        A5DG55RP.BH00019W * 
 * Target Table:    Extract - work.W2NQMC7B               A5DG55RP.BR0001U7 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.PARTY_LIVE); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NQMC7B;
quit;

proc sql;
   create view work.W2NQMC7B as
      select
         PARTY_RK,
         PARTY_ID
   from &SOURCEDS
      where PARTY_TYPE_CD = "FCFSUB"  & PARTY_CATEGORY_CD = "PTY"
   ;
quit;

%let SOURCEDS = work.W2NQMC7B;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TK * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    PARTY_LIVE - ecm_db.PARTY_LIVE        A5DG55RP.BH00019W * 
 * Target Table:    Extract - work.W2NQN1D0               A5DG55RP.BR0001U8 * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.PARTY_LIVE); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NQN1D0;
quit;

proc sql;
   create view work.W2NQN1D0 as
      select
         PARTY_RK,
         PARTY_ID
   from &SOURCEDS
      where PARTY_TYPE_CD = "FCFSUB"  & PARTY_CATEGORY_CD = "EXT"
   ;
quit;

%let SOURCEDS = work.W2NQN1D0;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TL * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Extract - work.W2NSDOYP               A5DG55RP.BR0001TZ * 
 *                  Extract - work.W2NQKB9C               A5DG55RP.BR0001U4 * 
 * Target Table:    Lookup - work.W2YT0EQC                A5DG55RP.BR0001U9 * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YT0EQC;
quit;

DATA  work.W2YT0EQC
         (keep = alert_id PARTY_RK )
      ; 
   
   attrib alert_id length=$32 format=$32. label="alert_id"
          PARTY_RK length=8 format=11. label="PARTY_RK"
          PARTY_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NQKB9C */ 
      nlobs = .; 
      dsid = open("work.W2NQKB9C"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NQKB9C", hashexp: exponent);
            h0.defineKey( "PARTY_ID");
            h0.defineData( "PARTY_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NQKB9C";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NQKB9C";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NQKB9C";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NQKB9C";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NQKB9C";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NQKB9C";
         
         abort 3; 
      end; 
      
      call missing (PARTY_ID, PARTY_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2NSDOYP end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: primary_entity_number);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YT0EQC; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PARTY_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YT0EQC; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TM * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Extract - work.W2NSEBPJ               A5DG55RP.BR0001U0 * 
 *                  Extract - work.W2NQL020               A5DG55RP.BR0001U5 * 
 * Target Table:    Lookup - work.W2YT11VG                A5DG55RP.BR0001UA * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YT11VG;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YT11VG
         (keep = alert_id PARTY_RK )
      ; 
   
   attrib alert_id length=$32 format=$32. label="alert_id"
          PARTY_RK length=8 format=11. label="PARTY_RK"
          PARTY_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NQL020 */ 
      nlobs = .; 
      dsid = open("work.W2NQL020"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NQL020", hashexp: exponent);
            h0.defineKey( "PARTY_ID");
            h0.defineData( "PARTY_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NQL020";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NQL020";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NQL020";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NQL020";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NQL020";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NQL020";
         
         abort 3; 
      end; 
      
      call missing (PARTY_ID, PARTY_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2NSEBPJ end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: primary_entity_number);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YT11VG; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PARTY_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YT11VG; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TN * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Extract - work.W2NSEULT               A5DG55RP.BR0001U1 * 
 *                  Extract - work.W2NQLMG0               A5DG55RP.BR0001U6 * 
 * Target Table:    Lookup - work.W2YT1PAT                A5DG55RP.BR0001UB * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YT1PAT;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YT1PAT
         (keep = alert_id PARTY_RK )
      ; 
   
   attrib alert_id length=$32 format=$32. label="alert_id"
          PARTY_RK length=8 format=11. label="PARTY_RK"
          PARTY_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NQLMG0 */ 
      nlobs = .; 
      dsid = open("work.W2NQLMG0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NQLMG0", hashexp: exponent);
            h0.defineKey( "PARTY_ID");
            h0.defineData( "PARTY_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NQLMG0";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NQLMG0";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NQLMG0";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NQLMG0";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NQLMG0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NQLMG0";
         
         abort 3; 
      end; 
      
      call missing (PARTY_ID, PARTY_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2NSEULT end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: primary_entity_number);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YT1PAT; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PARTY_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YT1PAT; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TO * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Extract - work.W2NSG82S               A5DG55RP.BR0001U2 * 
 *                  Extract - work.W2NQMC7B               A5DG55RP.BR0001U7 * 
 * Target Table:    Lookup - work.W2YT2996                A5DG55RP.BR0001UC * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YT2996;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YT2996
         (keep = alert_id PARTY_RK )
      ; 
   
   attrib alert_id length=$32 format=$32. label="alert_id"
          PARTY_RK length=8 format=11. label="PARTY_RK"
          PARTY_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NQMC7B */ 
      nlobs = .; 
      dsid = open("work.W2NQMC7B"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NQMC7B", hashexp: exponent);
            h0.defineKey( "PARTY_ID");
            h0.defineData( "PARTY_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NQMC7B";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NQMC7B";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NQMC7B";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NQMC7B";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NQMC7B";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NQMC7B";
         
         abort 3; 
      end; 
      
      call missing (PARTY_ID, PARTY_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2NSG82S end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: primary_entity_number);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YT2996; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PARTY_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YT2996; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TP * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Extract - work.W2NSGXF5               A5DG55RP.BR0001U3 * 
 *                  Extract - work.W2NQN1D0               A5DG55RP.BR0001U8 * 
 * Target Table:    Lookup - work.W2YT2XWG                A5DG55RP.BR0001UD * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YT2XWG;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YT2XWG
         (keep = alert_id PARTY_RK )
      ; 
   
   attrib alert_id length=$32 format=$32. label="alert_id"
          PARTY_RK length=8 format=11. label="PARTY_RK"
          PARTY_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NQN1D0 */ 
      nlobs = .; 
      dsid = open("work.W2NQN1D0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NQN1D0", hashexp: exponent);
            h0.defineKey( "PARTY_ID");
            h0.defineData( "PARTY_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NQN1D0";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NQN1D0";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NQN1D0";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NQN1D0";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NQN1D0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NQN1D0";
         
         abort 3; 
      end; 
      
      call missing (PARTY_ID, PARTY_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2NSGXF5 end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: primary_entity_number);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YT2XWG; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PARTY_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YT2XWG; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Extract                               A5DG55RP.BV0002TQ * 
 * Transform:       Extract                                                 * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    INCIDENT_LIVE - ecm_db.INCIDENT_LIVE  A5DG55RP.BH00019N * 
 * Target Table:    Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(ecm_db.INCIDENT_LIVE); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2NPPPX2;
quit;

proc sql;
   create view work.W2NPPPX2 as
      select
         INCIDENT_RK,
         INCIDENT_ID
   from &SOURCEDS
      where INCIDENT_TYPE_CD = "AMLALT"
   ;
quit;

%let SOURCEDS = work.W2NPPPX2;

/**  Step end Extract **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TR * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YT0EQC                A5DG55RP.BR0001U9 * 
 *                  Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 * Target Table:    Lookup - work.W2YVQLMX                A5DG55RP.BR0001UF * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YVQLMX;
quit;

DATA  work.W2YVQLMX
         (keep = PARTY_RK INCIDENT_RK )
      ; 
   
   attrib PARTY_RK length=8 format=11. label="PARTY_RK"
          INCIDENT_RK length=8 format=11. label="INCIDENT_RK"
          INCIDENT_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NPPPX2 */ 
      nlobs = .; 
      dsid = open("work.W2NPPPX2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NPPPX2", hashexp: exponent);
            h0.defineKey( "INCIDENT_ID");
            h0.defineData( "INCIDENT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NPPPX2";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NPPPX2";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NPPPX2";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NPPPX2";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NPPPX2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NPPPX2";
         
         abort 3; 
      end; 
      
      call missing (INCIDENT_ID, INCIDENT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2YT0EQC end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: alert_id);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YVQLMX; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (INCIDENT_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YVQLMX; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TS * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YT11VG                A5DG55RP.BR0001UA * 
 *                  Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 * Target Table:    Lookup - work.W2YVR6DW                A5DG55RP.BR0001UG * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YVR6DW;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YVR6DW
         (keep = PARTY_RK INCIDENT_RK )
      ; 
   
   attrib PARTY_RK length=8 format=11. label="PARTY_RK"
          INCIDENT_RK length=8 format=11. label="INCIDENT_RK"
          INCIDENT_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NPPPX2 */ 
      nlobs = .; 
      dsid = open("work.W2NPPPX2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NPPPX2", hashexp: exponent);
            h0.defineKey( "INCIDENT_ID");
            h0.defineData( "INCIDENT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NPPPX2";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NPPPX2";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NPPPX2";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NPPPX2";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NPPPX2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NPPPX2";
         
         abort 3; 
      end; 
      
      call missing (INCIDENT_ID, INCIDENT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2YT11VG end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: alert_id);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YVR6DW; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (INCIDENT_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YVR6DW; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TT * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YT1PAT                A5DG55RP.BR0001UB * 
 *                  Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 * Target Table:    Lookup - work.W2YVRTMM                A5DG55RP.BR0001UH * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YVRTMM;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YVRTMM
         (keep = PARTY_RK INCIDENT_RK )
      ; 
   
   attrib PARTY_RK length=8 format=11. label="PARTY_RK"
          INCIDENT_RK length=8 format=11. label="INCIDENT_RK"
          INCIDENT_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NPPPX2 */ 
      nlobs = .; 
      dsid = open("work.W2NPPPX2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NPPPX2", hashexp: exponent);
            h0.defineKey( "INCIDENT_ID");
            h0.defineData( "INCIDENT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NPPPX2";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NPPPX2";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NPPPX2";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NPPPX2";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NPPPX2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NPPPX2";
         
         abort 3; 
      end; 
      
      call missing (INCIDENT_ID, INCIDENT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2YT1PAT end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: alert_id);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YVRTMM; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (INCIDENT_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YVRTMM; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TU * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YT2996                A5DG55RP.BR0001UC * 
 *                  Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 * Target Table:    Lookup - work.W2YVSZ9K                A5DG55RP.BR0001UI * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YVSZ9K;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YVSZ9K
         (keep = PARTY_RK INCIDENT_RK )
      ; 
   
   attrib PARTY_RK length=8 format=11. label="PARTY_RK"
          INCIDENT_RK length=8 format=11. label="INCIDENT_RK"
          INCIDENT_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NPPPX2 */ 
      nlobs = .; 
      dsid = open("work.W2NPPPX2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NPPPX2", hashexp: exponent);
            h0.defineKey( "INCIDENT_ID");
            h0.defineData( "INCIDENT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NPPPX2";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NPPPX2";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NPPPX2";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NPPPX2";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NPPPX2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NPPPX2";
         
         abort 3; 
      end; 
      
      call missing (INCIDENT_ID, INCIDENT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2YT2996 end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: alert_id);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YVSZ9K; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (INCIDENT_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YVSZ9K; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Lookup                                A5DG55RP.BV0002TV * 
 * Transform:       Lookup                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YT2XWG                A5DG55RP.BR0001UD * 
 *                  Extract - work.W2NPPPX2               A5DG55RP.BR0001UE * 
 * Target Table:    Lookup - work.W2YVTXIE                A5DG55RP.BR0001UJ * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W2YVTXIE;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.W2YVTXIE
         (keep = PARTY_RK INCIDENT_RK )
      ; 
   
   attrib PARTY_RK length=8 format=11. label="PARTY_RK"
          INCIDENT_RK length=8 format=11. label="INCIDENT_RK"
          INCIDENT_ID length= $50
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table work.W2NPPPX2 */ 
      nlobs = .; 
      dsid = open("work.W2NPPPX2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "work.W2NPPPX2", hashexp: exponent);
            h0.defineKey( "INCIDENT_ID");
            h0.defineData( "INCIDENT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.W2NPPPX2";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " work.W2NPPPX2";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.W2NPPPX2";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " work.W2NPPPX2";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: work.W2NPPPX2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.W2NPPPX2";
         
         abort 3; 
      end; 
      
      call missing (INCIDENT_ID, INCIDENT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.W2YT2XWG end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find(key: alert_id);
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.W2YVTXIE; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (INCIDENT_RK); 
         etls_assign_target_value = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.W2YVTXIE; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

/**  Step end Lookup **/

/*==========================================================================* 
 * Step:            Append                                A5DG55RP.BV0002TW * 
 * Transform:       Append                                                  * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Tables:   Lookup - work.W2YVQLMX                A5DG55RP.BR0001UF * 
 *                  Lookup - work.W2YVR6DW                A5DG55RP.BR0001UG * 
 *                  Lookup - work.W2YVRTMM                A5DG55RP.BR0001UH * 
 *                  Lookup - work.W2YVSZ9K                A5DG55RP.BR0001UI * 
 *                  Lookup - work.W2YVTXIE                A5DG55RP.BR0001UJ * 
 * Target Table:    Append - work.W30Z2GNT                A5DG55RP.BR0001UK * 
 *==========================================================================*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W30Z2GNT;
quit;

data work.W30Z2GNT / view=work.W30Z2GNT;
   set work.W2YVQLMX
       work.W2YVR6DW
       work.W2YVRTMM
       work.W2YVSZ9K
       work.W2YVTXIE;
   keep PARTY_RK INCIDENT_RK; 
run;

/**  Step end Append **/

/*==========================================================================* 
 * Step:            Table Loader                          A5DG55RP.BV0002TX * 
 * Transform:       Table Loader (Version 2.1)                              * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    Append - work.W30Z2GNT                A5DG55RP.BR0001UK * 
 * Target Table:    New Incident X Parties -              A5DG55RP.BH0001AR * 
 *                   iem.New_Incident_X_Parties                             * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(work.W30Z2GNT); 

   data _null_;
      call symput('current_dt',put(datetime(),datetime22.));
   run;

   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5Y7GK1Y;
   quit;
   
   proc sql;
      create view work.W5Y7GK1Y as
         select
            INCIDENT_RK,
            PARTY_RK,
            ("ALT2SUB") as RELATION_TYPE_CD length = 10
               format = $10.
               informat = $10.,
            ("") as RELATION_DESC length = 100
               format = $100.
               informat = $100.,
            ("&current_dt"dt) as CREATE_DTTM length = 8
               format = DATETIME27.6
               informat = DATETIME27.6
      from &SOURCEDS
      ;
   quit;
   
   %let SOURCEDS = work.W5Y7GK1Y;
   
   proc datasets lib = iem nolist nowarn memtype = (data view);
      delete New_Incident_X_Parties;
   quit;
   
   data iem.New_Incident_X_Parties;
      attrib INCIDENT_RK length = 8
         format = 11.
         informat = 11.; 
      attrib PARTY_RK length = 8
         format = 11.
         informat = 11.; 
      attrib RELATION_TYPE_CD length = $10
         format = $10.
         informat = $10.
         label = 'RELATION_TYPE_CD'; 
      attrib RELATION_DESC length = $100
         format = $100.
         informat = $100.
         label = 'RELATION_DESC'; 
      attrib CREATE_DTTM length = 8
         format = DATETIME27.6
         informat = DATETIME27.6; 
      call missing(of _all_);
      stop;
   run;
   
proc append base = iem.New_Incident_X_Parties 
   data = &SOURCEDS force;
 run; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5Y7GK1Y;
quit;

/**  Step end Table Loader **/

/*==========================================================================* 
 * Step:            Table Loader                          A5DG55RP.BV0002TZ * 
 * Transform:       Table Loader (Version 2.1)                              * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    New Incident X Parties -              A5DG55RP.BH0001AR * 
 *                   iem.New_Incident_X_Parties                             * 
 * Target Table:    INCIDENT_X_PARTY -                    A5DG55RP.BH00019S * 
 *                   ecm_db.INCIDENT_X_PARTY                                * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(iem.New_Incident_X_Parties); 
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5Y7GK2P;
   quit;
   
   proc sql;
      create view work.W5Y7GK2P as
         select
            INCIDENT_RK,
            PARTY_RK,
            RELATION_TYPE_CD,
            RELATION_DESC,
            CREATE_DTTM
      from &SOURCEDS
      ;
   quit;
   
   %let SOURCEDS = work.W5Y7GK2P;
      
   proc append base = ecm_db.INCIDENT_X_PARTY 
      data = &SOURCEDS force;
    run; 
      
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5Y7GK2P;
   quit;

/**  Step end Table Loader **/

/*==========================================================================* 
 * Step:            Table Loader                          A5DG55RP.BV0002TY * 
 * Transform:       Table Loader (Version 2.1)                              * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    Append - work.W30Z2GNT                A5DG55RP.BR0001UK * 
 * Target Table:    New Events - iem.new_events           A5DG55RP.BH0001AP * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(work.W30Z2GNT); 

   data _null_;
      call symput('current_dt',put(datetime(),datetime22.));
   run;

   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5Y7GK9Y;
   quit;
   
   proc sql;
      create view work.W5Y7GK9Y as
         select
            . as EVENT_RK length = 8
               format = 11.
               informat = 11.,
            ("INCIDENT") as BUSINESS_OBJECT_NM length = 100
               format = $100.
               informat = $100.,
            INCIDENT_RK as BUSINESS_OBJECT_RK,
            ("ADDPAR") as EVENT_TYPE_CD length = 10
               format = $10.
               informat = $10.,
            ("ALT2SUB") as EVENT_DESC length = 256
               format = $256.
               informat = $256.,
            ("&ecm_user") as CREATE_USER_ID length = 60
               format = $60.
               informat = $60.,
            ("&current_dt"dt) as CREATE_DTTM length = 8
               format = DATETIME27.6
               informat = DATETIME27.6,
            ("PARTY") as LINKED_OBJECT_NM length = 100
               format = $100.
               informat = $100.,
            PARTY_RK as LINKED_OBJECT_RK
      from &SOURCEDS
      ;
   quit;
   
   %let SOURCEDS = work.W5Y7GK9Y;
 
   proc datasets lib = iem nolist nowarn memtype = (data view);
      delete new_events;
   quit;
      
   data iem.new_events;
      attrib EVENT_RK length = 8
         format = 11.
         informat = 11.
         label = 'EVENT_RK';
      attrib BUSINESS_OBJECT_NM length = $100
         format = $100.
         informat = $100.
		 label = 'BUSINESS_OBJECT_NM'; 
      attrib BUSINESS_OBJECT_RK length = 8
         format = 11.
         informat = 11.
         label = 'BUSINESS_OBJECT_RK'; 
      attrib EVENT_TYPE_CD length = $10
         format = $10.
         informat = $10.
         label = 'EVENT_TYPE_CD'; 
      attrib EVENT_DESC length = $256
         format = $256.
         informat = $256.
         label = 'EVENT_DESC'; 
      attrib CREATE_USER_ID length = $60
         format = $60.
         informat = $60.
         label = 'CREATE_USER_ID'; 
      attrib CREATE_DTTM length = 8
         format = DATETIME27.6
         informat = DATETIME27.6
         label = 'CREATE_DTTM'; 
      attrib LINKED_OBJECT_NM length = $100
         format = $100.
         informat = $100.
         label = 'LINKED_OBJECT_NM'; 
      attrib LINKED_OBJECT_RK length = 8
         format = 11.
         informat = 11.
         label = 'LINKED_OBJECT_RK'; 
      call missing(of _all_);
      stop;
   run;

proc append base = iem.new_events 
   data = &SOURCEDS force;
 run; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5Y7GK9Y;
quit;

/*---- Start of Post-Process Code  ----*/ 

%let obs_count = %fcf_get_observation_count(table=iem.new_events, SASDATASET=Y);
%let numevents = &obs_count;

%fcf_get_ecm_sequence_ids(numIDs=&numevents, ecmSeq=event);

data iem.new_events;
	set iem.new_events;
	event_rk = symgetn('seqId'||(kstrip(put(_n_,best32.))));
run;
/*---- End of Post-Process Code  ----*/ 

/**  Step end Table Loader **/

/*==========================================================================* 
 * Step:            Table Loader                          A5DG55RP.BV0002U0 * 
 * Transform:       Table Loader (Version 2.1)                              * 
 * Description:                                                             * 
 *                                                                          * 
 * Source Table:    New Events - iem.new_events           A5DG55RP.BH0001AP * 
 * Target Table:    ECM_EVENT - ecm_db.ECM_EVENT          A5DG55RP.BH00019J * 
 *==========================================================================*/ 

%let SOURCEDS = %nrquote(iem.new_events); 
      
   proc append base = ecm_db.ECM_EVENT 
      data = &SOURCEDS force;
    run; 
   
/**  Step end Table Loader **/

%mend;
